<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>My Calendar</title>
    <style>
        table {
            width: 90%;
            border: 1px solid #444444;            
            }
        td {
            width: 30px;
            height: 30px;
            text-align: center;
            font-size: 15px;
            font-family: Consolas;
            border: 1px solid #444444;            
            };        
    </style>    
</head>
<body>
    <table id="calendar">
        <tr>
            <td id="lastMonth" colspan="1"><<</td>
            <td id="presentMonth" colspan="5">YEAR년 MONTH월</td>
            <td id="nextMonth" colspan="1">>></td>
        </tr>
        <tr>
            <td class="sun"><font color=red>일</font></td>
            <td class="mon">월</td>
            <td class="tue">화</td>
            <td class="wed">수</td>
            <td class="thu">목</td>
            <td class="fri">금</td>
            <td class="sat"><font color=blue>토</font></td>
        </tr>
    </table>
    <script>
        var date = new Date();          // 현재 일자 만들기
        var month = date.getMonth();    // 이번달 가져오기 
        var year = date.getFullYear();  // 이번해 가져오기
        var lastDate;                   // 이번달 말일 변수 선언
        thisMonthCal( year, month );    // 이번달 달력 호출하여 이번달 달력 출력

        var preMonthElement = document.getElementById("lastMonth"); // lastMonth id 요소를 가져와 노드 만들기
        preMonthElement.addEventListener("click", preMonthCal);     // 클릭 이벤트로 preMonthCal 호출
        
        var nextMonthElement = document.getElementById("nextMonth");// nextMonth id 요소를 가져와 노드 만들기
        nextMonthElement.addEventListener("click", nextMonthCal);   // 클릭 이벤트로 nextMonthCal
        
        function preMonthCal() {            // 전달 달력 만들기
            month -= 1;                     // 전달 변수에 할당
            if ( month == -1 ) {            // 전달이 -1 이면 전달로 11(12월)로 할당 (month는 0달부터 11달까지)
                month = 11;
                year -= 1;                  // 전달이 12월이되면 연도를 지난해로 할당
            }
            thisMonthCal( year, month );    // 이번달 호출하여 전달 만들기
        }

        function nextMonthCal() {           // 다음달 달력 만들기
            month += 1;                     // 다음달 변수에 할당
            if ( month == 12 ) {            // 다음달이 12 이면 다음달 0(1월)로 할당
                month = 0;                  
                year += 1;                  // 다음달이 1월이되면 연도를 다음해도 할당
            }
            thisMonthCal( year, month );    // 이번달 호출하여 다음달 만들기
        }

        function thisMonthCal( year, month ) {              // 이번달 만들기 

            var setDate = new Date(year, month + 1, 0 );    // 이번달 말일 가져오기
            lastDate = setDate.getDate();                   

            var thisMonth = document.getElementById("presentMonth");    // presentMonth id 가져와 노드 만드길
            thisMonth.innerHTML = year + "년 " + (month + 1) + "월";    // presentMonth id 태그에 이번달 연월 넣어 표시

            var table = document.getElementById("calendar");        // table 태그 노드 만들기
            var tRows = table.rows.length;                          // table 태그 안에 행 갯수 확인
            if ( tRows > 2 ) {                                      // table 기본행 갯수 보다 많을 경우
                for ( let i = (tRows-1); i > 1; i-- ) {             // 새로운 달력 만들기 위해서 행 삭제
                    table.deleteRow(i);
                }
            }
            
            var firstDate = new Date(year, month, 1);   // 이번달 1일 가져오기
            var firstDay = firstDate.getDay();          // 이번달 1일 요일 가져오기 
           
            var row;                                    // 행 변수 선언
            var cell;                                   // 열 변수 선언
            var sevenCount = 0;                         // 7일씩(열 7개) 출력하기 위한 카운터 변수
            var rowCounter = 2;                         // table 추가될 행 변수 초기화
            row = table.insertRow(rowCounter);          // 추가행 만들기

            for ( var i = 0; i < firstDay; i++ ) {      // 이번달 1일의 요일 전일까지 빈열 넣기                
                cell = row.insertCell();                // 반복하여 열 추가하기
                sevenCount += 1;                        // 추가된 열의 갯수 누적
            }

            for ( var j = 1; j <= lastDate; j++ ) {     // 1일부터 이번달 말일까지 반복순회
                cell = row.insertCell();                // 1일과 함께 열넣기
                sevenCount += 1;                        // 추가된 빈열이어서 누적              
                                    
                if ( sevenCount % 7 == 0 ) {            // 7일째이면 (토요일이면)
                    cell.innerHTML = "<font color=blue>" + j;   // 날짜 색을 파란색으로
                    rowCounter += 1;                            // 7일이 되었으므로 다음 행 추가 할 인덱스 증가 
                    row = table.insertRow(rowCounter);          // 다음 행 추가
                } else if ( sevenCount % 7 == 1 ) {             // 1일째이면 (일요일이면)
                    cell.innerHTML = "<font color=red>" + j;    // 날짜 색을 빨간색으로
                } else {
                    cell.innerHTML = j;                         // 날짜를 태그에 넣기
                }
            }
            
            var lastDay = setDate.getDay();                     // 마지막날 요일 가져오기
            if ( lastDay != 6 ) {                               // 마자막날 다음 빈열 채우기
                for ( let i = (lastDay + 1); i <= 6; i++ ) {
                    cell = row.insertCell();
                }
            }
        }
    </script>
    
</body>
</html>